Linux命令之exit-退出当前shell【返回值状态】
⽤途说明
exit命令⽤于退出当前shell,在shell脚本中可以终⽌当前脚本执⾏。
常⽤参数
格式:exit n
退出。设置退出码为n。(Cause the shell to exit with a status of n.)
格式:exit
退出。退出码不变,即为最后⼀个命令的退出码。(If n is omitted, the exit status is that of the last command executed. )
格式:$?
上⼀个命令的退出码。
格式:trap "commands" EXIT
退出时执⾏commands指定的命令。( A trap on EXIT is executed before the shell terminates.)
退出码(exit status,或exit code)的约定:
0表⽰成功(Zero - Success)
⾮0表⽰失败(Non-Zero - Failure)
2表⽰⽤法不当(Incorrect Usage)
127表⽰命令没有到(Command Not Found)
126表⽰不是可执⾏的(Not an executable)
>=128 信号产⽣
man 3 exit 写道
The C standard specifies two constants, EXIT_SUCCESS and EXIT_FAILURE, that may be passed to exit() to indicate successful or unsuccessful termination, respectively.
以下摘⾃/usr/include/stdlib.h
#define EXIT_FAILURE 1 /* Failing exit status. */
#define EXIT_SUCCESS 0 /* Successful exit status. */
BSD试图对退出码标准化。
man 3 exit 写道
BSD has attempted to standardize exit codes; see the file <sysexits.h>.
以下摘⾃/usr/include/sysexits.h
#define EX_OK 0 /* successful termination */
#define EX__BASE 64 /* base value for error messages */
#define EX_USAGE 64 /* command line usage error */
#define EX_DATAERR 65 /* data format error */
#define EX_NOINPUT 66 /* cannot open input */
#define EX_NOUSER 67 /* addressee unknown */
#define EX_NOHOST 68 /* host name unknown */
#define EX_UNAVAILABLE 69 /* service unavailable */
#define EX_SOFTWARE 70 /* internal software error */
#define EX_OSERR 71 /* system error (e.g., can't fork) */
#define EX_OSFILE 72 /* critical OS file missing */
#define EX_CANTCREAT 73 /* can't create (user) output file */
#define EX_IOERR 74 /* input/output error */
#define EX_TEMPFAIL 75 /* temp failure; user is invited to retry */
#define EX_PROTOCOL 76 /* remote error in protocol */
#define EX_NOPERM 77 /* permission denied */
#define EX_CONFIG 78 /* configuration error */
#define EX__MAX 78 /* maximum listed value */
使⽤⽰例
⽰例⼀退出当前shell
[root@new55 ~]# [root@new55 ~]# exit logout
⽰例⼆在脚本中,进⼊脚本所在⽬录,否则退出
Bash代码
cd $(dirname $0) || exit 1
⽰例三在脚本中,判断参数数量,不匹配就打印使⽤⽅式,退出if [ "$#" -ne "2" ]; then
echo "usage: $0 <area> <hours>"
exit 2
fi
⽰例四在脚本中,退出时删除临时⽂件
trap "rm -f tmpfile; echo Bye." EXIT
⽰例五检查上⼀命令的退出码
./mycommand.sh
EXCODE=$?
if [ "$EXCODE" == "0" ]; then
echo "O.K"
fi
问题思考
相关资料
linux执行shell命令
【1】91linux 【2】曲径通幽【3】Linux⼤学
版权声明:本站内容均来自互联网,仅供演示用,请勿用于商业和其他非法用途。如果侵犯了您的权益请与我们联系QQ:729038198,我们将在24小时内删除。
发表评论